/*=====================================================================
File: QuickWineTemplate.cs

Summary: Creation rapide de vin

Date : Fev 2007

Origin: Open Cellar ! Project

Revision:

Aut: Matthieu DUCROCQ

---------------------------------------------------------------------
Copyright (C) N/A
=====================================================================*/
using System;
using OpenCellar.Application;
using OpenCellar.Framework.Core;

namespace OpenCellar.AddIn.QuickWineTemplate
{
	/// <summary>
	/// QuickWineTemplate.
	/// </summary>
	public class QuickWineTemplate : IAddIn
	{
		
		/// <summary>
		/// Initialise une instance de clase QuickWineTemplate.
		/// </summary>
		public QuickWineTemplate(){}

		public void OnUnInitialize()
		{
			m_app = null;
		}

		private IApplication m_app = null;

		/// <summary>
		/// Obtient une rfrence vers l'application.
		/// </summary>
		private IApplication App
		{
			get
			{
				return(m_app);
			}
		}

		public void OnInitialize(IApplication application)
		{
			m_app = application;
			AttachListener();
		}

		public void OnCommand(int command){}

		public void OnRegisterMenus(AddInMenus addInMenus){}

		private void AttachListener()
		{
			m_app.NewWindow+=new WindowEventHandler(OnNewWindow);
		}

		private void OnNewWindow(object sender, WindowEventArgs e)
		{
			//
			// Si la fenetre est de type emplacement, plug sur le clic droit
			//
			if(e.Window.Type == WindowType.Rack)
			{
				((IRackWindow)e.Window).WineContext+=new ContextMenuEventHandler(OnMenuItemClick);
			}
		}

		private RackItem m_item = null;

		/// <summary>
		/// Obtient l'lement selectionn.
		/// </summary>
		private RackItem Item
		{
			get
			{
				return(m_item);
			}
		}

		const string MAIN_MENU_TEXT = "Bibliothque de modles";

		/// <summary>
		/// Se produit lors d'un clic sur un element d'emplacement.
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		private void OnMenuItemClick(object sender, ContextMenuEventArgs e)
		{
			m_item = e.Item;

			//
			// Charge la liste de modeles disponibles
			//
			if(e.Item.IsEmpty) // Verifie que l'element est vide
			{
				if(m_app.WineTemplates.Count > 0)
				{
					e.SetMainMenuText(MAIN_MENU_TEXT);

					for (int i = 0; i < m_app.WineTemplates.Count; i++)
					{
						e.Register(m_app.WineTemplates[i].ToString(), 
							new System.EventHandler(OnQuickMenu));
					}
				}
			}
		}

		private void OnQuickMenu(object sender, EventArgs e)
		{
			//
			// Recupere le modele selectionne
			//
			string menuText = sender.ToString();
			
			//
			// Recherche le modele
			//
			for (int i = 0; i < m_app.WineTemplates.Count; i++)
			{
				if(m_app.WineTemplates[i].ToString() == menuText)
				{
					//
					// Creation du vin
					//
					Wine w = (Wine)m_app.ActiveCellar.CreateItem(OpenCellar.Framework.Core.ObjectType.Wine);
					App.WineTemplates[i].CreateWine(w);

					//
					// Affectation de l'emplacement a la file d'attente
					//
					w.RackItemWorkqueue.Set(WorkqueueItemType.Add, Item);		
					
					//
					// Affichage de la fenetre.
					//
					IWindow window = m_app.GetWindow(WindowType.Wine, w);
					if(window != null)
					{
						window.Show();
					}

					break;					
				}
			}
		}
	}
}
